<?php

class MobipAPI {

	public function __construct( $id, $secret, $url ) {
		$this->id = $id;
		$this->secret = $secret;
		$this->url = $url;
	}

	public function mobip_api_get_token() {

		if (!empty($this->id) && !empty($this->secret)) {
			$response = json_decode(wp_remote_retrieve_body(wp_remote_get( $this->url . MOBIP_API_TOKEN . '?api_account_id=' . strtolower($this->id) . '&api_secret_key=' . strtolower($this->secret) ) ), true);
			if (0 == $response['return_code']) {
				return $response['access_token'];
			}
		}

		return null;
	}

	public function mobip_api_send_request( $order_id, $item_name, $total, $redirect_url, $customer_name = '', $customer_email = '', $customer_phone = '' ) {

		$access_token = $this->mobip_api_get_token();

		if ($access_token) {
			$body = array(
				'track_id' => $order_id,
				'item_name' => $item_name,
				'tax_amount_in_cents' => 0,
				'item_amount_in_cents' => $total,
				'call_back_url' => get_site_url() . '/wp-json/mobip/v1/payment-callback',
				'redirect_url' => $redirect_url,
				'customer_name' => $customer_name,
				'customer_email' => $customer_email,
				'customer_phone' => $customer_phone,
				'access_token' => $access_token
			);
			$args = array(
				'body'        => $body,
				'timeout'     => '5',
				'redirection' => '5',
				'httpversion' => '1.0',
				'blocking'    => true,
				'headers'     => array(),
				'cookies'     => array(),
			);
		   return json_decode(wp_remote_retrieve_body(wp_remote_post( $this->url . MOBIP_API_ONE_USE_QR, $args )), true);
		}

		return null;
	}

	public function mobip_api_is_valid( $trid ) {

		$access_token = $this->mobip_api_get_token();

		if ($access_token) {
		   return json_decode(wp_remote_retrieve_body(wp_remote_get( $this->url . MOBIP_API_IS_VALID . '?access_token=' . $access_token . '&trid=' . $trid )), true);
		}

		return null;
	}
}
